﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace SIDU_Linq {
	public partial class _Default : System.Web.UI.Page {
		DAL dal = new DAL();
		protected void Page_Load(object sender, EventArgs e) {
			if (!IsPostBack) {
				GridView1.DataSource = dal.GetAllProducts();
				GridView1.DataBind();
			}
			ThisProductForm.onSaveClick += new EventHandler(ThisProductForm_onSaveClick);
			ThisProductForm.onDeleteClick += new EventHandler(ThisProductForm_onDeleteClick);
			ThisProductForm.Name.BackColor =
				ThisProductForm.Code.BackColor =
				ThisProductForm.CountryOfOrigin.BackColor = System.Drawing.Color.Yellow;
			ThisProductForm.Msg.Width = 300;
		}

		void ThisProductForm_onDeleteClick(object sender, EventArgs e) {
			try {
				if (dal.DeleteProduct(int.Parse(ThisProductForm.ProductID.Text))) {
					GridView1.DataSource = dal.GetAllProducts();
					GridView1.DataBind();
					GridView1.SelectedIndex = -1;
					ThisProductForm.Msg.ForeColor = System.Drawing.Color.Blue;
					ThisProductForm.Msg.Text = "OK";
					ThisProductForm.Clear_Click(null, null);
				}
				else {
					ThisProductForm.Msg.ForeColor = System.Drawing.Color.Red;
					ThisProductForm.Msg.Text = "Database error";
				}
			}
			catch {
				ThisProductForm.Msg.ForeColor = System.Drawing.Color.Red;
				ThisProductForm.Msg.Text = "Select the product to delete";
			}
		}

		void ThisProductForm_onSaveClick(object sender, EventArgs e) {
			Product product = new Product();
			try {
				if (ThisProductForm.DataMissing()) {
					throw new Exception();
				}
				bool ret_val;
				product.Name = ThisProductForm.Name.Text;
				product.Code = ThisProductForm.Code.Text;
				product.CountryOfOrigin = ThisProductForm.CountryOfOrigin.Text;
				product.OnSale = ThisProductForm.OnSale.Checked;
				if (ThisProductForm.ProductID.Text != String.Empty)
					ret_val = dal.UpdateProduct(int.Parse(ThisProductForm.ProductID.Text), product);
				else
					ret_val = dal.InsertProduct(product);
				if (ret_val) {
					GridView1.DataSource = dal.GetAllProducts();
					GridView1.DataBind();
					GridView1.SelectedIndex = -1;
					ThisProductForm.Msg.ForeColor = System.Drawing.Color.Blue;
					ThisProductForm.Msg.Text = "OK";
				}
				else {
					ThisProductForm.Msg.ForeColor = System.Drawing.Color.Red;
					ThisProductForm.Msg.Text = "Database error";
				}
			}
			catch {
				ThisProductForm.Msg.ForeColor = System.Drawing.Color.Red;
				ThisProductForm.Msg.Text = "Missing data";
			}
		}

		protected void GridView1_SelectedIndexChanged(object sender, EventArgs e) {
			Product prod = dal.GetProductByCode(GridView1.SelectedRow.Cells[2].Text);
			ThisProductForm.ProductID.Text = prod.ProductID.ToString();
			ThisProductForm.Name.Text = prod.Name;
			ThisProductForm.Code.Text = prod.Code;
			ThisProductForm.CountryOfOrigin.Text = prod.CountryOfOrigin;
			ThisProductForm.OnSale.Checked = prod.OnSale;
			ThisProductForm.Msg.Text = String.Empty;
		}
	}
}
