﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace SimpleLinqDemo {
	public partial class _Default : System.Web.UI.Page {
		protected void Page_Load(object sender, EventArgs e) {
			NorthwindDataContext db = new NorthwindDataContext();
			if (Session["skip"] == null)
				Session["skip"] = 0;
			else
				Session["skip"] = (int)Session["skip"] + 10;
			int skip = (int)Session["skip"];
			var query1 = (from p in db.Products
										where p.Category.Products.Count > 5
										select p).Skip(skip).Take(10);
			var query2 = from q in query1
									 select new {
										 q.ProductID,
										 q.ProductName,
										 TotalUnits = q.Order_Details.Sum(o => o.Quantity),
										 Revenue = q.Order_Details.Sum(o => o.Quantity * o.UnitPrice)
									 };
			// Put a breakpoint onto the next line and study the generated SQL commands
			GridView1.DataSource = query2;
			GridView1.DataBind();
		}
	}
}

